/**
 *	@file	FindFile.h
 *	@brief	ChJ[hw肵ăt@Cꗗ擾. ċAw\.
 *	@author	tenk* (Masashi Kitamura)
 *	@note
 *	-	win ܂ linux(unix) p.
 *	-	fname.h includeĂÃt@Cinclude΁A
 *		fnamẽ[`p. łȂΌ֊֐̃NXɗp.
 *	-	Public Domain Software
 */

#ifndef FINDFILE_H_INCLUDED
#define FINDFILE_H_INCLUDED


#if defined _WIN32
 #pragma once
 #include <windows.h>
 #include <tchar.h>
 #if defined _MSC_VER
  #pragma comment(lib, "User32.lib")			// CharNext()ŕKv...
  #pragma warning(disable: 4244)
 #endif
#else	// O[oԂA}N̍Ē`͑v낤Ƃtchar֌W̒날킹.
 #define  _LARGEFILE64_SOURCE
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
 #include <unistd.h>
 #include <dirent.h>
 #include <sys/stat.h>
 #include <fnmatch.h>
 #ifndef TCHAR
  #define TCHAR		char
  #define _T(x)		x
 #endif
#endif


#include <assert.h>
#include <stddef.h>
#include <time.h>


// pX̒ݒ.
#ifdef FINDFILE_MAX_PATH		// ݒς݂Ȃ炻𗘗p.
#elif  defined FNAME_MAX_PATH	// fname.h includeς݂Ȃ炻ɏ].
#define FINDFILE_MAX_PATH		FNAME_MAX_PATH
#elif  defined _MAX_PATH		// dos/winn̒`.
#define FINDFILE_MAX_PATH		_MAX_PATH
#else							// Ȃ K.
#define FINDFILE_MAX_PATH		1024
#endif


// ----------------------------------------------------------------------------

/// t@CpNX.
template<unsigned N = FINDFILE_MAX_PATH >
class FindFileT {
public:
	FindFileT() : recFlag_(0), srchLen_(0) { pathBuf_[0] = 0, srchName_[0] = 0; }
	template<class FNC>
	FindFileT(const TCHAR* srchName, unsigned flags, FNC& fnc) { scan(srchName, flags, fnc); }

	template<class FNC>
	unsigned scan(const TCHAR* srchName, unsigned flags, FNC fnc);

private:
	template<class FNC>
	unsigned scan_sub(FNC& fnc);

  #ifndef FNAME_INCLUDED
	TCHAR*		fname_baseName(const TCHAR* path);
	TCHAR*		fname_cpy(TCHAR dst[], unsigned sz, const TCHAR* src);
  #endif

private:
	TCHAR		pathBuf_ [ N ];
	TCHAR		srchName_[ N ];
	unsigned	srchLen_;
	bool		recFlag_;
	bool		hiddonFlag_;
};



/** t@C.
 */
template<unsigned N>
template<class FNC>
unsigned	FindFileT<N>::scan(const TCHAR* srchName, unsigned flags, FNC fnc)
{
	fname_cpy(pathBuf_ , N, srchName );
	TCHAR* 				baseName 	= fname_baseName(pathBuf_);
	fname_cpy(srchName_, N, baseName );
	bool recFlag = (flags & 1) != 0;
	#if 1	// "**" ̎wċAwƂ݂Ȃ.
	{
		TCHAR* p = srchName_;
		TCHAR* d = srchName_;
		while (*p) {
			if (*p == '*' && p[1] == '*') {
				recFlag = 1;
				++p;
			}
			*d++ = *p++;
		}
		*d = 0;
	}
	#endif
	recFlag_	= recFlag;
	hiddonFlag_ = (flags & 2) != 0;

  #ifdef _WIN32
	srchLen_ = _tcslen(srchName_);
  #else
	srchLen_ = strlen(srchName_);
	if (baseName == pathBuf_) {
		fname_cpy(pathBuf_, N, _T("./"));
	}
  #endif

	//func_	= fnc;
	return scan_sub(fnc);
}



/** t@C̃Tu[`. ċA.
 */
template<unsigned N>
template<class FNC>
unsigned	FindFileT<N>::scan_sub(FNC& fnc)
{
  #if defined _WIN32
	unsigned 			num 	  	= 0;
	WIN32_FIND_DATA		findData	= {0};
	WIN32_FIND_DATA*	pFindData 	= &findData;	// new WIN32_FIND_DATA;
	HANDLE 				hdl 		= FindFirstFile(pathBuf_, pFindData);
	size_t				baseNameSz 	= N - _tcslen(pathBuf_);
	TCHAR* 				baseName 	= fname_baseName(pathBuf_);
	*baseName  	= _T('\0');

	if (hdl != INVALID_HANDLE_VALUE) {
		// t@C擾.  Bt@C͑ΏۊOɂĂ.
		do {
			fname_cpy(baseName, baseNameSz, pFindData->cFileName );
			if ((pFindData->dwFileAttributes & (FILE_ATTRIBUTE_DIRECTORY|FILE_ATTRIBUTE_HIDDEN)) == 0) {
				fnc( pathBuf_, pFindData );
				++num;
			}
		} while (FindNextFile(hdl, pFindData) != 0);
		FindClose(hdl);
	}

	// fBNgċAŃt@C擾.
	if (recFlag_ && baseNameSz >= 16) {
		fname_cpy(baseName, 4, _T("*.*") );
		hdl = FindFirstFile(pathBuf_, pFindData);
		if (hdl != INVALID_HANDLE_VALUE) {
			do {
				fname_cpy(baseName, baseNameSz, pFindData->cFileName );
				if ((pFindData->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
					if (_tcscmp(baseName, _T(".")) == 0 || _tcscmp(baseName, _T("..")) == 0
						|| (pFindData->dwFileAttributes & FILE_ATTRIBUTE_HIDDEN))			// BtH_͑ΏۊO.
					{
						;
					} else {
						size_t l = _tcslen(baseName);
						if (l+2+srchLen_ < baseNameSz) {
							fname_cpy(baseName+l  , baseNameSz-l  , _T("/"));
							fname_cpy(baseName+l+1, baseNameSz-l-1, srchName_ );
							num += scan_sub(fnc);
						}
					}
				}
			} while (FindNextFile(hdl, pFindData) != 0);
			FindClose(hdl);
		}
	}
	// delete pFindData;
	return num;

  #else	// linux/unixn...
	struct dirent**	namelist = 0;
	unsigned 		num 	 = 0;
	int				dirNum;
	TCHAR*			baseName;
	size_t			baseNameSz;

	baseName 	= fname_baseName(pathBuf_);
	*baseName  	= 0;
	baseNameSz 	= N - strlen(pathBuf_);
	assert(baseNameSz < FINDFILE_MAX_PATH);

	// fBNgGg̎擾.
	baseName[-1] = 0;
	dirNum = scandir(pathBuf_, &namelist, 0, alphasort);
	baseName[-1] = _T('/');

	if (namelist) {
		struct stat statBuf;
		int			i;

		// t@C擾.
		for (i = 0; i < dirNum; ++i) {
			struct dirent* d = namelist[i];
			if (fnmatch(srchName_, d->d_name, FNM_NOESCAPE) == 0) {
				fname_cpy(baseName, baseNameSz, d->d_name );
				if (stat(pathBuf_, &statBuf) >= 0) {
					if ((statBuf.st_mode & S_IFMT) != S_IFDIR) {
						fnc( pathBuf_ , &statBuf );
						++num;
					}
				}
			}
		}

		// fBNg΍ċA.
		if (recFlag_ && baseNameSz >= 16) {
			for (i = 0; i < dirNum; ++i) {
				struct dirent* d = namelist[i];
				fname_cpy(baseName, baseNameSz, d->d_name );
				if (stat(pathBuf_, &statBuf) >= 0 && strcmp(baseName,_T(".")) && strcmp(baseName,_T(".."))) {
					if ((statBuf.st_mode & S_IFMT) == S_IFDIR) {
						size_t l = strlen(baseName);
						if (l+2+srchLen_ < baseNameSz) {
							fname_cpy(baseName+l  , baseNameSz-l  , _T("/"));
							fname_cpy(baseName+l+1, baseNameSz-l-1, srchName_ );
							num += scan_sub(fnc);
						}
					}
				}
			}
		}

		// gJ.
		for (i = 0; i < dirNum; ++i) {
			free( namelist[i] );
		}
		free( namelist );
	}
	return num;
  #endif
}



// ----------------------------------------------------------------------------
// t@C֌W.

#ifndef FNAME_INCLUDED
/** t@CpX̃fBNgt@C̈ʒuԂ.
 */
template<unsigned N>
TCHAR *FindFileT<N>::fname_baseName(const TCHAR *adr) {
	const TCHAR *p = adr;
	assert(adr != 0);
	while (*p) {
	  #ifdef _WIN32
		if (*p == ':' || *p == '/'|| *p == '\\') adr = (TCHAR*)p + 1;
		p = CharNext(p);
	  #else
		if (*p == ':' || *p == '/'			   ) adr = (TCHAR*)p + 1;
		p += 1;
	  #endif
	}
	return (TCHAR*)adr;
}


/** t@C̃Rs[.
 */
template<unsigned N>
TCHAR *FindFileT<N>::fname_cpy(TCHAR dst[], unsigned dstSz, const TCHAR* src) {
	const TCHAR*	s = src;
	const TCHAR*	e = s + dstSz-1;
	TCHAR*			d = dst;
	while (s < e && *s)
		*d++ = *s++;
	*d = 0;
	return dst;
}
#endif



// ----------------------------------------------------------------------------
// Ώۂ̃f[^󂯎邽߂̃NX.

/// t@Ĉ݂̈ꗗ쐬p.
template<class CONTA>
struct FindFile_Get_Name {
public:
	typedef typename CONTA::value_type	value_type;

	FindFile_Get_Name(CONTA& rConta) : rConta_(rConta) {}
	void operator()(const TCHAR* path, const void*) {
		rConta_.push_back( value_type(path) );
	}

private:
	//FindFile_Get_Name(const FindFile_Get_Name&);
	void operator=(const FindFile_Get_Name&);

private:
	CONTA&	rConta_;
};


/// t@CƃTCŸꗗ쐬p.
template<class CONTA>
struct FindFile_Get_NameSize {
public:
	typedef typename CONTA::value_type	value_type;

	FindFile_Get_NameSize(CONTA& rConta) : rConta_(rConta) {}
  #ifdef _WIN32
	void operator()(const TCHAR* path, const WIN32_FIND_DATA* f) {
		rConta_.push_back( value_type(path, (((unsigned __int64)f->nFileSizeHigh<<32)|f->nFileSizeLow) ) );
	}
  #else
	void operator()(const TCHAR* path, const struct stat* st) {
		rConta_.push_back( value_type(path, st->st_size) );
	}
  #endif

private:
	void operator=(const FindFile_Get_NameSize&);

private:
	CONTA&	rConta_;
};


/// t@CƃTCYƍŏIݎԂ̈ꗗ쐬p.
template<class CONTA>
struct FindFile_Get_NameSizeTime {
public:
	typedef typename CONTA::value_type	value_type;

	FindFile_Get_NameSizeTime(CONTA& rConta) : rConta_(rConta) {}
  #ifdef _WIN32
	void operator()(const TCHAR* path, const WIN32_FIND_DATA* f) {
		unsigned __int64 sz 	= (((unsigned __int64)f->nFileSizeHigh<<32) | f->nFileSizeLow);
		unsigned __int64 wrtTim = *(unsigned __int64*)&f->ftLastWriteTime;
		rConta_.push_back( value_type(path, sz, wrtTim ) );
	}
  #else
	void operator()(const TCHAR* path, const struct stat *st) {
		rConta_.push_back( value_type(path, st->st_size, st->st_mtime) );
	}
  #endif

private:
	void operator=(const FindFile_Get_NameSizeTime&);

private:
	CONTA&	rConta_;
};


/// t@Cstruct stat ̈ꗗ쐬p.
template<class CONTA>
struct FindFile_Get_NameStat {
public:
	typedef typename CONTA::value_type	value_type;

	FindFile_Get_NameStat(CONTA& rConta) : rConta_(rConta) {}
  #ifdef _WIN32
	void operator()(const TCHAR* path, const WIN32_FIND_DATA* f) {
		struct _tstat64 st;
		::_tstat64(path, &st);
		rConta_.push_back( value_type(path, &st ) );
	}
  #else
	void operator()(const TCHAR* path, const struct stat *st) {
		rConta_.push_back( value_type(path, st) );
	}
  #endif

private:
	void operator=(const FindFile_Get_NameStat&);

private:
	CONTA&	rConta_;
};



// ----------------------------------------------------------------------------
// ۂɌĂяo֐.

/** t@C̈ꗗ쐬.
 *	Rei̗vf 󂯎邱.
 *	@param	rConta		ʂ󂯎Rei. push_back()\Ȃ.
 *	@param	srchPath	pXw
 *	@param	flags		bit0(1):ċAȂonw.  bit1(2):Bt@CȂonw.
 */
template<class CONTA >
unsigned	FindFile_name(CONTA& rConta, const TCHAR* srchPath, unsigned flags=0) {
	return FindFileT<>().scan( srchPath, flags, FindFile_Get_Name<CONTA>(rConta) );
}



/** t@CƃTCŸꗗ쐬.
 *	Rei̗vf ƃTCY󂯎NXł邱.
 *	@param	rConta		ʂ󂯎Rei. push_back()\Ȃ.
 *	@param	srchPath	pXw
 *	@param	flags		bit0(1):ċAȂonw.  bit1(2):Bt@CȂonw.
 */
template<class CONTA >
unsigned	FindFile_nameSize(CONTA& rConta, const TCHAR* srchPath, unsigned flags=0) {
	return FindFileT<>().scan( srchPath, flags, FindFile_Get_NameSize< CONTA >(rConta) );
}


/** t@CƃTCYƍŏIݎԂ̈ꗗ쐬.
 *	Rei̗vf ƃTCYƎԂ󂯎NXł邱.
 *	@param	rConta		ʂ󂯎Rei. push_back()\Ȃ.
 *	@param	srchPath	pXw
 *	@param	flags		bit0(1):ċAȂonw.  bit1(2):Bt@CȂonw.
 */
template<class CONTA >
unsigned	FindFile_nameSizeTime(CONTA& rConta, const TCHAR* srchPath, unsigned flags=0) {
	return FindFileT<>().scan( srchPath, flags, FindFile_Get_NameSizeTime< CONTA >(rConta) );
}

	#if 0	// FindFile_nameSizeTime p̃NX.
	/// t@CƃTCYƍŏIݎԂ̍\.
	struct findfile_name_size_time_t {
		findfile_name_size_time_t(
			const TCHAR* name=_T(""),
			uint64_t	 size=0,
			uint64_t	 time=0
		) : name_(name), size_(size), time_(time)
		{
		}
	  #ifdef UNICODE
		std::wstring 	name_;
	  #else
		std::string 	name_;
	  #endif
		uint64_t		size_;
		uint64_t		time_;
	};

	typedef std::vector< findfile_name_size_time_t > fildFile_name_size_time_vec_t;
	typedef std::list< findfile_name_size_time_t >	 fildFile_name_size_time_list_t;
	#endif


/** t@Cstruct _stat64(win) / stat(winȊO) ̈ꗗ쐬.
 *	Rei̗vf stat(64)|C^TCY󂯎NXł邱.
 *	@param	rConta		ʂ󂯎Rei. push_back()\Ȃ.
 *	@param	srchPath	pXw
 *	@param	flags		bit0(1):ċAȂonw.  bit1(2):Bt@CȂonw.
 */
template<class CONTA >
unsigned	FindFile_nameStat(CONTA& rConta, const TCHAR* srchPath, unsigned flags=0) {
	return FindFileT<>().scan( srchPath, flags, FindFile_Get_NameStat< CONTA >(rConta) );
}


#endif	// FINDFILE_H_INCLUDED
