/**
 *	@file	?.cpp
 *	@brief
 *	@author	tenk*
 *	@date	200?-??
 *	@note
 *		ႢR}hCc[p̐`.
 */

#include "../FindFile.h"
#include "./TimeCnv.h"

#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <string>


static bool one(const char* name);
static bool option(const char* arg);



/** g.
 */
static int usage()
{
	fprintf(stderr, "usage>test_findfile [-opts] file(s)\n"
		  );
	return 0;
}



/** C.
 */
int main(int argc, const char* argv[])
{
	int		i;

	if (argc < 2)
		return usage();

	// IvV擾.
	for (i = 1; i < argc; ++i) {
		if (argv[i][0] == '-') {
			if (option(argv[i]) == 0)
				return 1;
		}
	}

	// t@C擾.
	for (i = 1; i < argc; ++i) {
		const char* p = argv[i];
		if (*p != '-') {
			if (one(p) == 0)
				return 1;
		}
	}

	return 0;
}



/** IvV̏.
 */
bool option(const char* arg)
{
	const char* p = arg;
	switch (*p) {
	case '?':
		usage();
		break;

	default:
		fprintf(stderr, "bad option '%s'", arg);
		return 0;
	}
	return 1;
}


class FileNameSizeTime {
public:
	FileNameSizeTime(const char* name=0, unsigned long long size=0, unsigned long long time=0)
		: name_(name), size_(size), time_(time)
	{
	}
	std::string			name_;
	unsigned long long	size_;
	unsigned long long	time_;
};

/** t@CP̏.
 */
bool one(const char* name) {
  #if 0
	std::vector<std::string> vec;
	vec.reserve(4096);
	FindFile_name(vec, name);
	for (unsigned i = 0; i < vec.size(); ++i) {
		printf("%s\n", vec[i].c_str());
	}
  #else
	std::vector<FileNameSizeTime> vec;
	vec.reserve(4096);
	FindFile_nameSizeTime(vec, name);
	for (unsigned i = 0; i < vec.size(); ++i) {
		TimeCnv_time_t	ftim = vec[i].time_;
		TimeCnv_TmEx	tm;
		TimeCnv_Tm_from_UtcTime(&tm, ftim);
		printf("%-32s %10lld ", vec[i].name_.c_str(), vec[i].size_);
		printf("\t%4d-%02d-%02d %2d:%02d:%02d.%03d\n",tm.year(), tm.month(), tm.day(), tm.hour(), tm.minute(), tm.second(), tm.milliseconds() );
	}
  #endif
	return 1;
}
